//---------------------------------------------------------------------------
#include <vcl.h>
#include <list.h>
#pragma hdrstop

#include "sivia.h"
#include "repere.h"
#include "box.h"


//---------------------------------------------------------------------------
#pragma package(smart_init)
//----------------------------------------------------------------------
repere R;

iboolean Inside(box& P)
{   iboolean dedans;
    interval Ym=Sqr(P[1])+Sqr(P[2])+P[1]*P[2];
    dedans=In(Ym,interval(1,2));
    return dedans;
};
//----------------------------------------------------------------------
void SIVIApile(box& P)
{   box P1(2,true);
    box P2(2,true);
    if (Width(P)<0.01)
    {     R.DrawBox(P,clYellow,clYellow,bsSolid); return;  };
    iboolean test=Inside(P);
    if (test==itrue)   { R.DrawBox(P,clRed,clPurple,bsSolid); }
    else if (test!=ifalse)
         {  Bisect(P,P1,P2);
            SIVIApile(P1);
            SIVIApile(P2);
         }
    else R.DrawBox(P,clBlue,clOlive,bsSolid);
} ;

void SIVIAfile(box P)
{   box P1(2,true);
    box P2(2,true);
    list<box> L;
    L.push_back(P);
    while (!L.empty())
    { P=L.front();
      L.pop_front();
      iboolean test=Inside(P);
      if (Width(P)<0.01)     R.DrawBox(P,clYellow,clYellow,bsSolid);
      else if (test==itrue)  R.DrawBox(P,clRed,clPurple,bsSolid);
      else if (test==ifalse) R.DrawBox(P,clBlue,clOlive,bsSolid);
      else  {   Bisect(P,P1,P2);
                L.push_back(P1);
                L.push_back(P2);
            }
    }
} ;
//----------------------------------------------------------------------
void GO(repere& R1,box& P,int i)
{   R=R1;
    if (i==0) SIVIApile(P);
    if (i==1) SIVIAfile(P);
} ;
//----------------------------------------------------------------------

